<?php

namespace Ulmus\Adapter;

use Ulmus\Common\PdoObject;
use Ulmus\Migration\FieldDefinition;

interface AdapterInterface {
    public const IDENTIFIER_FIELD = 1;
    public const IDENTIFIER_TABLE = 2;
    public const IDENTIFIER_DATABASE = 3;
    public const IDENTIFIER_SCHEMA = 4;
    public const IDENTIFIER_VALUE = 5;

    public function connect() : object /* | PdoObject|mixed */;
    public function buildDataSourceName() : string;
    public function setup(array $configuration) : void;
    public function writableValue(/* mixed */ $value); /*: mixed*/
    public function repositoryClass() : string;
    public function queryBuilderClass() : string;
}
